%{
#define YY_ConfigParser_STYPE yy_ConfigParser_stype

%}

%name ConfigParser
%define LSP_NEEDED
%define ERROR_BODY =0
%define LEX_BODY =0

%define YY_ConfigParser_MEMBERS ConfigFile config_file_;

%header{
#define YY_DECL int yyFlexLexer::yylex(YY_ConfigParser_STYPE *val)
#define YY_ConfigParser_MEMBERS ConfigFile config_file_;\
                                virtual ~ConfigParser() {};
#ifndef FLEXFIX
#define FLEXFIX YY_ConfigParser_STYPE *val
#define FLEXFIX2 val
#endif

#include <iostream>
#include <string>
#include "config_file.h"
using namespace std;


%}

%union {
  int   int_val;
  char* string;
}

%token <string> T_SECTION
%token <string> T_STRING

%left <i> '=' ';' 

%start config_file

%%
config_file	: /* empty */
		| section_list
		;

section_list	: section
		| section_list section
		;

section		: /* empty */	
		| section_header statement_list
		;

section_header	: T_SECTION { 
//			cout << "Section: " << $1 << endl; 
			config_file_.addSection($1);
			free($1);
		}
		;

statement_list	: /* empty */
		| statement
		| statement_list statement
		;

statement	: T_STRING '=' T_STRING {
//			cout << $1 << " is " << $3 << endl; 
			config_file_.addParameter(config_file_.current_section_,
						  $1, $3);
			free($1);
			free($3);
		}

%%

