// $Id: dockapp.h,v 1.13 2003/02/09 19:28:00 gordon Exp $	
//
// Copyright (C) 2002 Gordon Fraser <gordon@debian.org>
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// See the COPYING file for more details
//

#ifndef __dockapp_h__
#define __dockapp_h__

#include <stdio.h>
#include <string.h>
#include <iostream>
#include <string>

#include "theme.h"
#include "graphics.h"
#include "mixer.h"

//--------------------------------------------------------------------
class DockApp 
{
 protected:
  Mixer* mixer_;
  unsigned *icons_;
  Graphics* graphics_;
  Theme* theme_;

  void drawBar(unsigned value, unsigned offset, unsigned width);
  void drawLeftButton(bool state);
  void drawRightButton(bool state);
  void drawMuteButton(bool state);
  void drawRecButton(bool state, unsigned current_channel);

 public:
  DockApp(Mixer*, int, char**, const string&, const string&, const string&, char);
  virtual ~DockApp();

  bool isLeftButton(unsigned x, unsigned y) const;
  bool isRightButton(unsigned x, unsigned y) const;
  bool isMuteButton(unsigned x, unsigned y) const;
  bool isRecButton(unsigned x, unsigned y) const;
  bool isVolumeBar(unsigned x, unsigned y) const;
  bool isLeftVolumeBar(unsigned x, unsigned y) const;
  bool isRightVolumeBar(unsigned x, unsigned y) const;

  void drawRightBar(unsigned value);
  void drawLeftBar(unsigned value);
  void drawMonoBar(unsigned value);

  void drawButtons(bool, bool, bool, bool, unsigned);

  void drawIcon(unsigned icon);
  void drawCounter(unsigned value);
  void drawLabel(const string& label);
  void drawBackground();

  unsigned normalize(unsigned, unsigned) const;

  // obsolete
  void setLedColor(char *);
  void setLedHighColor(char *);
  void setBackColor(char *);

  XHandler* getXHandler() const;
  Display*  getDisplay() const;

  void update(unsigned current_channel, bool state_left, 
	      bool state_right, bool state_mute,
	      bool state_rec, unsigned dragging = 0);
};

#endif //__dockapp_h__
