// $Id: oss_device.cc,v 1.8 2003/01/07 20:53:08 gordon Exp $	
//
// Copyright (C) 2002 Gordon Fraser <gordon@debian.org>
// Parts copyright (C) 1998  Sam Hawker <shawkie@geocities.com>
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// See the COPYING file for more details
//

#include "oss_device.h"

//----------------------------------------------------------------------
OSSDevice::OSSDevice(bool is_supported, bool is_stereo, bool is_recordable,
		     bool record_source, unsigned mask, const string& device_name)
  : Device(is_supported, is_stereo, is_recordable, record_source, device_name),
    mask_(mask)
{

}

//----------------------------------------------------------------------
OSSDevice::~OSSDevice()
{
}

//----------------------------------------------------------------------
unsigned OSSDevice::getValue() const
{
  return (right_value_ << 8) + left_value_;
}

//----------------------------------------------------------------------
void OSSDevice::setValue(unsigned value)
{
  left_value_ = value % 256;
  right_value_ = value >> 8;
}

//----------------------------------------------------------------------
unsigned OSSDevice::getMask() const
{
  return mask_;
}

//----------------------------------------------------------------------
bool OSSDevice::toggleRecordSource()
{
  record_source_ = !record_source_;
  return record_source_;
}

//----------------------------------------------------------------------
void OSSDevice::setRecordSource(bool record)
{
  record_source_ = record;
}

//----------------------------------------------------------------------
bool OSSDevice::isRecordSource()
{
  return record_source_;
}

