// $Id: oss_mixer.h,v 1.14 2003/03/11 19:40:42 gordon Exp $	
//
// Copyright (C) 2002 Gordon Fraser <gordon@debian.org>
// Parts copyright (C) 1998  Sam Hawker <shawkie@geocities.com>
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// See the COPYING file for more details
//

#ifndef __oss_mixer_h__
#define __oss_mixer_h__

#include <sys/ioctl.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>

#ifdef __NetBSD__
#include <soundcard.h>
#endif
#ifdef __FreeBSD__
#include <machine/soundcard.h>
#endif
#ifdef __linux__
#include <linux/soundcard.h>
#endif

#include <errno.h>


#include "mixer.h"
#include "oss_device.h"
#include <iostream>
#include <string>

// oh wtf...
#define DEFAULT_DEVICE "/dev/mixer"

//----------------------------------------------------------------------
class OSSMixer : public Mixer
{
 protected:
  //  static const string DEFAULT_DEVICE = "/dev/mixer";
  //  string device_name_;
  int capabilities_;            // capabilities

  OSSDevice** devices_;  
  int file_descriptor_;
  int modify_counter_;

  void writeChannel(unsigned channel_num) throw(InvalidChannelException);
  void initMixer() throw(MixerDeviceException);

 public:
  OSSMixer() throw(MixerDeviceException);
  OSSMixer(const string&) throw(MixerDeviceException);
  virtual ~OSSMixer();

  virtual void muteChannel(unsigned)  
    throw(InvalidChannelException);
  virtual void unMuteChannel(unsigned)
    throw(InvalidChannelException);
  
  virtual void setChannelLeft(unsigned, unsigned)
    throw(InvalidChannelException);
  virtual void setChannelRight(unsigned, unsigned)
    throw(InvalidChannelException);
  
  virtual bool toggleChannelRecord(unsigned)  
    throw(InvalidChannelException);
  
  virtual bool hasChanged();
  virtual void doUpdate();
  virtual void doUpdate(unsigned);

  virtual bool isMuted(unsigned) const
    throw(InvalidChannelException);
  virtual bool isMono(unsigned) const
    throw(InvalidChannelException);
  virtual bool isSupported(unsigned) const
    throw(InvalidChannelException);
  virtual bool isEnabled(unsigned) const
    throw(InvalidChannelException);
  virtual bool canCapture(unsigned) const
    throw(InvalidChannelException);
  virtual bool getCapture(unsigned) const  
    throw(InvalidChannelException);

  virtual unsigned getChannelLeft(unsigned) const
    throw(InvalidChannelException);
  virtual unsigned getChannelRight(unsigned) const
      throw(InvalidChannelException);
  virtual const string& getChannelName(unsigned) const
    throw(InvalidChannelException);
  virtual void disableChannel(unsigned)
    throw(InvalidChannelException);
  virtual void enableChannel(unsigned)
    throw(InvalidChannelException);
};

#endif //__oss_mixer_h__
